import { world, system } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

system.events.beforeWatchdogTerminate.subscribe(data => {
  data.cancel = true;
});

let w = world.getDimension("overworld");

world.events.beforeItemUse.subscribe(data => {
  var players = Array.from(world.getPlayers());
  var p = data.source;
  switch (data.item.typeId) {
    case "emotes:emotes_item_click": {
      const form = new ActionFormData()
        .title("EMOTES")
        .button("Dab", "textures/ui/1")
        .button("Twerking", "textures/ui/2")
        .button("LMAO", "textures/ui/3")
        .button("Cry", "textures/ui/4")
        .button("Desperate", "textures/ui/5")
        .button("T - Pose", "textures/ui/6")
        .button("Slap", "textures/ui/7")
        .button("Flip", "textures/ui/8")
        .button("Throwing Money", "textures/ui/9")
        .button("Floss", "textures/ui/10")
        .button("Champion", "textures/ui/11")
        .button("You're Dead", "textures/ui/12")
        .button("I'm Here", "textures/ui/13")
        .button("...", "textures/ui/14")
        .button("Arigato", "textures/ui/15")
        .button("Lie Down", "textures/ui/16")
        .button("Sitting", "textures/ui/17")
        .button("Take the L", "textures/ui/18")
        .button("Best Mates", "textures/ui/19")
        .button("Idle", "textures/ui/20")
        .button("Flow", "textures/ui/21")
        .button("Skibidi", "textures/ui/22")
        .button("Clubbing", "textures/ui/23")
        .button("Squat", "textures/ui/24")
        .button("Hype", "textures/ui/25")

      form.show(p).then(async (response) => {
        if (response.selection === 0) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.custom.dab animation.humanoid.custom.dab`)
        }
        else if (response.selection === 1) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.custom.perreo animation.humanoid.custom.perreo`)
        }
        else if (response.selection === 2) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.custom.risa animation.humanoid.custom.risa`)
        }
        else if (response.selection === 3) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.custom.llorar animation.humanoid.custom.llorar`)
        }
        else if (response.selection === 4) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.desesperado animation.humanoid.desesperado`)
        }
        else if (response.selection === 5) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.t-pose animation.humanoid.t-pose`)
        }
        else if (response.selection === 6) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.cachetada animation.humanoid.customm.cachetada`)
        }
        else if (response.selection === 7) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.flip_atras animation.humanoid.flip_atras`)
        }
        else if (response.selection === 8) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.melapelas animation.humanoid.melapelas`)
        }
        else if (response.selection === 9) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.baile animation.humanoid.baile`)
        }
        else if (response.selection === 10) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.campeon animation.humanoid.customm.campeon`)
        }
        else if (response.selection === 11) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.muerto`)
        }
        else if (response.selection === 12) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.aquiestoy animation.humanoid.aquiestoy`)
        }
        else if (response.selection === 13) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.naca animation.humanoid.naca`)
        }
        else if (response.selection === 14) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.arigato animation.humanoid.arigato`)
        }
        else if (response.selection === 15) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_16 acostarse 1000000`)
        }
        else if (response.selection === 16) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_17 sentarse 1000000`)
        }
        else if (response.selection === 17) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_18 animation.humanoid.customm.baile_18`)
        }
        else if (response.selection === 18) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_19 animation.humanoid.customm.baile_19`)
        }
        else if (response.selection === 19) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_20 animation.humanoid.customm.baile_20`)
        }
        else if (response.selection === 20) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_21 animation.humanoid.customm.baile_21`)
        }
        else if (response.selection === 21) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_22 animation.humanoid.customm.baile_22`)
        }
        else if (response.selection === 22) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_23 animation.humanoid.customm.baile_23`)
        }
        else if (response.selection === 23) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_24 animation.humanoid.customm.baile_24`)
        }
        else if (response.selection === 24) {
          await p.runCommandAsync(`playanimation @s animation.humanoid.customm.baile_25 animation.humanoid.customm.baile_25`)
        }
      });
    } break;
    default:
      break;
  }
});

world.events.tick.subscribe(function () {

  let levelPlayers = Array.from(world.getPlayers());

  levelPlayers.forEach(async player => {
    if (player.velocity.x > 0 || player.velocity.z > 0 || player.velocity.y > 0) {

      await player.runCommandAsync(`playanimation @s animation.humanoid.base_pose`);
    }
    else if (player.isSneaking) {

      await player.runCommandAsync(`playanimation @s animation.humanoid.base_pose`);

    }
  });
});


world.events.beforeChat.subscribe(async (emotes) => {
  let prefix = 'c/';
  let msg = emotes.message;
  let command = 'emotes';
  const sender = emotes.sender;

  if (msg.toLowerCase().startsWith(prefix + command)) {
    emotes.cancel = true;
    await sender.runCommandAsync(`give @s emotes:emotes_item_click`)
  }
});